program SimpleRoundToEx_Demo;

{$APPTYPE CONSOLE}

uses
  Windows,
  Math,
  SysUtils,
  SimpleRoundToEx in 'SimpleRoundToEx.pas';

var
  Start: Cardinal;
  I, A: Integer;
  Initial: Extended;
  AsmResult, StrResult, DefaultResult, InitialStr: string;
  ErrorCount: array [0..1] of Integer = (0, 0);
begin
  try
    Randomize;

    Writeln('Start speed test');

    Write('SimpleRoundTo: ');
    Start := GetTickCount;
    for I := -9 to 10 do
      for A := 0 to 10000 do
      begin
        SimpleRoundTo(-99999.1132123123, I);
        SimpleRoundTo(0, I);
        SimpleRoundTo(99999.1132123123, I);
      end;
    Writeln(GetTickCount - Start);

    Write('SimpleRoundTo_Asm: ');
    Start := GetTickCount;
    for I := -9 to 10 do
      for A := 0 to 10000 do
      begin
        SimpleRoundTo_Asm(-99999.1132123123, I);
        SimpleRoundTo_Asm(0, I);
        SimpleRoundTo_Asm(99999.1132123123, I);
      end;
    Writeln(GetTickCount - Start);

    Write('SimpleRoundTo_Str: ');
    Start := GetTickCount;
    for I := -9 to 10 do
      for A := 0 to 10000 do
      begin
        SimpleRoundTo_Str(-99999.1132123123, I);
        SimpleRoundTo_Str(0, I);
        SimpleRoundTo_Str(99999.1132123123, I);
      end;
    Writeln(GetTickCount - Start);

    Writeln('Speed test done');
    Writeln;
    Writeln('Start round test');
    Writeln;

    for I := 0 to 1000 do
    begin

      Initial := Random(MaxInt) / Random(MaxInt) * Random(MaxInt);
      asm
        rdtsc
        mov A, eax
      end;

      A := abs(A);
      case A mod 8 of
        0: while Initial > 1 do  Initial := Initial / 10;
        1: while Initial > 10 do  Initial := Initial / 10;
        2: while Initial > 100 do  Initial := Initial / 10;
        3: while Initial > 1000 do  Initial := Initial / 10;
        4: while Initial > 10000 do  Initial := Initial / 10;
        5: while Initial > 100000 do  Initial := Initial / 10;
        6: while Initial > 1000000 do  Initial := Initial / 10;
        7: while Initial > 10000000 do  Initial := Initial / 10;
      end;

      asm
        rdtsc
        mov A, eax
      end;

      if A mod 2 = 1 then
        Initial := Initial * -1;

      InitialStr := FloatToStr(Initial);

      for A := -9 to 9 do
      begin
        AsmResult := FloatToStr(SimpleRoundTo_Asm(Initial, A));
        DefaultResult := FloatToStr(SimpleRoundTo(Initial, A));
        StrResult := FloatToStr(SimpleRoundTo_Str(Initial, A));
        if AsmResult <> StrResult then
        begin
          Writeln('SimpleRoundTo_Asm(', InitialStr, ', ', A, ') failed: ',
            AsmResult, ' valid value = ', StrResult);
          Inc(ErrorCount[0]);
        end;
        if DefaultResult <> StrResult then
        begin
          Writeln('SimpleRoundTo(', InitialStr, ', ', A, ') failed: ',
            DefaultResult, ' valid value = ', StrResult);
          Inc(ErrorCount[1]);
        end;
      end;

    end;
  except
    on E: Exception do
      Writeln(E.ClassName, ': ', E.Message);
  end;

  Writeln;
  Writeln('Round test done');
  Writeln;
  Writeln('SimpleRoundTo_Asm errors: ', ErrorCount[0]);
  Writeln('SimpleRoundTo errors: ', ErrorCount[1]);
  Readln;
end.
